# 56. Завантажити фотографії

Завантаження фотографії через S3 містить 2 кроки:

1. **Запитати попередньо підписане посилання для подальшого прямого завантаження.**&#x20;

Як вхідні дані:&#x20;

* fileExtention - jpeg АБО jpg АБО png,&#x20;
* farmUuid - uuid ферми,
* fieldUuid - uuid поля,
* noteUuid - uuid нотатки для прямого посилання на завантажену фотографію,
* commentUuid - uuid коментаря для прямого посилання на завантажену фотографію (необов’язково).&#x20;

Як вихідні дані:

* uuid - очікуваний uuid після завантаження та обробки,
* farmUuid - те саме, що вхідне,
* fieldUuid - те саме, що вхідне,
* noteUuid - те саме, що вхідне,
* commentUuid - те саме, що вхідне (якщо існувало),
* s3Url - URL, який використовується для завантаження фотографії,
* s3Fields - атрибути, які потрібно передати в формі завантаження фотографії.

Деталі щодо використання s3Url та s3Fields описані в другому кроці.&#x20;

Атрибути дійсні лише 60 хвилин для завантаження фотографії.

{% code overflow="wrap" lineNumbers="true" %}

```graphql
mutation generatePresignedPostPhotoData {
  generatePresignedPostPhotoData(input:{
    farmUuid: "89196056-61e5-4bce-b676-d488d611a829" 
    fieldUuid: "586a2ef2-03e4-4715-846c-07a2f0cb3016"
    noteUuid: "4a94da1c-f655-4f17-961a-4b0323e5129c"
    fileExtention: jpeg
    
  } ) {
    uuid
    noteUuid
    fieldUuid
    farmUuid
    s3Url
    s3Fields
  }
}
```

{% endcode %}

2. **Надіслати локальну фотографію на s3Url з попередньо визначеними атрибутами форми з s3Fields.**

{% code overflow="wrap" lineNumbers="true" %}

```bash
curl --location --request POST '<s3Url>' \\
--form 'key="<value_in_s3Fields>"' \\
--form 'AWSAccessKeyId="<value_in_s3Fields>"' \\
--form 'x-amz-security-token="<value_in_s3Fields>"' \\
--form 'policy="<value_in_s3Fields>"' \\
--form 'signature="<value_in_s3Fields>"' \\
--form 'file=@"<local_file_path>"'
```

{% endcode %}

Повідомлення про обробку будуть доставлені через механізм підписки, описаний у GraphQL -> Samples -> [1. Підписка: Отримати події](/geopard-tutorials/ukrainian/dokumentaciya-api/oglyad-zapitiv-geopard-api/1.-pidpiska-otrimati-podiyi.md).

{% hint style="info" %}
Використовуйте ‘Accept-Encoding’:’gzip, deflate, br’.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.geopard.tech/geopard-tutorials/ukrainian/dokumentaciya-api/oglyad-zapitiv-geopard-api/56.-zavantazhiti-fotografiyi.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
